--  Declare Saved Variables
farmed_options = 
{
    show=true,
    showslotcount=true
  
};

--- Declare Other Variables



--- Init Code and Support Functions

function farmed_Message(msg)
    DEFAULT_CHAT_FRAME:AddMessage("|cFF2080D0[Farmed]|r "..msg);
end

function farmed_OnLoad(self)

    SLASH_FARMED1="/farmed";
    SlashCmdList["FARMED"] = farmed_SlashCommand;
    
    if (farmed_options.show==false) then
          farmed_hide();
    end

    
  
   
    
    farmed_gen();
    
    this:RegisterEvent("ADDON_LOADED");
    this:RegisterEvent("BAG_UPDATE");
    farmed_Message(farmed_lang_loaded);

end

-- Command Line Manager

function farmed_SlashCommand(msg)
    farmed_Message("cmd recvd!!!");
    
    msg = string.lower(msg);
   local args = {};
   for word in string.gmatch(msg, "[^%s]+") do
   	table.insert(args, word);
   end
   
   ----PROCESS COMMAND LINE
   
   if ( args[1] ) then
	  if ( args[1] == "show" ) then
	     farmed_options.show=true;
         Farmed:Show();
	  
	  elseif ( args[1] == "hide" ) then
	      farmed_options.show=false;
          Farmed:Hide();
      else
         farmed_Message("|cffff0000Unrecognised command.");
        
      end
    else
        farmed_Message("Farmed Commands:");
        farmed_Message("     show - show farmed window");
        farmed_Message("     hide - hide farmed window");
    end
end

function farmed_hide()
    Farmed:Hide();
end

function farmed_write(htmltext, rows)
    Farmed_html:SetText(htmltext);
    --resize window to take into account html size
    Farmed:SetHeight((rows*11)+15);
end
--- Core Processing Loop
function farmed_gen()
    local rowcount=1;
    local html="<html><body>";
    
    --- Get Bag Slot Count
   -- if (farmed_options.showslotcount) then
        html = html .. "<h2>|cFF91D0F2" .. farmed_lang_bags .. " |cFFFFF000";
        local totslots=0;
        local freeslots=0;
        
        for n= 0,4 do
            local slots = GetContainerNumSlots(n);
            totslots=totslots+slots;
            
            for f= 1,slots do
                if (GetContainerItemLink(n,f)==nil) then
                    freeslots=freeslots+1;
                end
            end
        
        end
        
        html = html .. freeslots .."/" .. totslots .. " |r</h2>";
        rowcount=rowcount+1;
    --end
    
    
    --- Process List
    
    local resh, resc;
    
    resh, resc = farmed_checkbag(farmed_metals,farmed_lang_ore);
    html = html ..resh;
    rowcount=rowcount+resc;
    
    resh, resc = farmed_checkbag(farmed_stone,farmed_lang_stone);
    html = html ..resh;
    rowcount=rowcount+resc;
    
    resh, resc = farmed_checkbag(farmed_gem,farmed_lang_gem);
    html = html ..resh;
    rowcount=rowcount+resc;
    
    resh, resc = farmed_checkbag(farmed_cloth,farmed_lang_cloth);
    html = html ..resh;
    rowcount=rowcount+resc;
    
    resh, resc = farmed_checkbag(farmed_leather,farmed_lang_leather);
    html = html ..resh;
    rowcount=rowcount+resc;
    
    resh, resc = farmed_checkbag(farmed_herb,farmed_lang_herb);
    html = html ..resh;
    rowcount=rowcount+resc;
    
    resh, resc = farmed_checkbag(farmed_element,farmed_lang_element);
    html = html ..resh;
    rowcount=rowcount+resc;
    
    resh, resc = farmed_checkbag(farmed_herb,farmed_lang_other);
    html = html ..resh;
    rowcount=rowcount+resc;
    
    --Finish HTML
    
    html =html .."</body></html>";
    
   -- farmed_Message(html);
    
    farmed_write(html, rowcount)
end

function farmed_checkbag(typearray,typename)
    
    local htmlblock=""
    
    local has_title=false;
    local icount=0;
    local rc=0;
    
    for index,value in ipairs(typearray) do 
        
        local icount=GetItemCount(value);
        if (icount >0) then
        
            local itemName, itemLink, itemRarity, itemLevel, itemMinLevel, itemType, itemSubType, itemStackCount, itemEquipLoc, itemTexture = GetItemInfo(value);
        
            if (has_title==false) then
                htmlblock = htmlblock .. "<h3><br/>|cFF91D0F2" .. typename .. " " .. farmed_lang_gathered .. "|r</h3>";
                rc=rc+2;
                has_title=true;
            end
            
            local r,g,b, colcode = GetItemQualityColor(itemRarity);
            
            htmlblock = htmlblock .. "<p>" .. colcode .. itemName .. ": |cFFFFF000" .. icount .." |r</p>";
            rc=rc+1;
            
            --farmed_Message(htmlblock);
        end
    end

    return htmlblock, rc;
end

--Event Management
function farmed_event()
    if (event=="ADDON_LOADED") then
        
        
    elseif (event=="BAG_UPDATE") then
    
        farmed_gen();
    
    end


end
